' declare external libraries.
DECLARE LIBRARY
    FUNCTION CreateFile& (filename$, BYVAL access&, BYVAL sharing&, BYVAL sec_attr%&, BYVAL create&, BYVAL flags&, BYVAL template%&)
    FUNCTION MoveFile (f$, g$)
    FUNCTION CopyFile (f$, g$, BYVAL f%)
    FUNCTION EncryptFile (f$)
    FUNCTION DecryptFile (f$, BYVAL f&)
END DECLARE
DECLARE DYNAMIC LIBRARY "kernel32"
    FUNCTION DeleteFileA% (F$)
    FUNCTION RemoveDirectoryA% (F$)
    FUNCTION CreateDirectoryA% (F$, BYVAL X&&)
    FUNCTION SetCurrentDirectoryA% (f$)
    FUNCTION CloseHandle& (BYVAL handle&)
    FUNCTION GetLastError& ()
    FUNCTION FormatMessageA& (BYVAL f AS LONG, f$, BYVAL e AS LONG, BYVAL d AS LONG, g$, s AS LONG, h$)
END DECLARE
DECLARE DYNAMIC LIBRARY "advapi32"
    FUNCTION FileEncryptionStatusA% (f$, f&)
END DECLARE
DO
    COLOR 15
    PRINT _CWD$
    PRINT "Main Options:"
    PRINT "  (D)irectory"
    PRINT "  (F)iles"
    PRINT "  (Q)uit"
    PRINT "Enter option?";
    DO
        _LIMIT 50
        LOCATE , , 1
        x$ = INKEY$
        IF LEN(x$) THEN
            PRINT
            EXIT DO
        END IF
    LOOP
    IF UCASE$(x$) = "Q" THEN COLOR 7: END
    SELECT CASE UCASE$(x$)
        CASE "D"
            DO
                COLOR 15
                PRINT "Directory Options:"
                PRINT "  (C)reate directory"
                PRINT "  (R)emove directory"
                PRINT "  (S)et current directory"
                PRINT "  (Q)uit"
                PRINT "Enter option?";
                DO
                    _LIMIT 50
                    LOCATE , , 1
                    x$ = INKEY$
                    IF LEN(x$) THEN
                        PRINT
                        EXIT DO
                    END IF
                LOOP
                IF UCASE$(x$) = "Q" THEN EXIT DO
                SELECT CASE UCASE$(x$)
                    CASE "C"
                        PRINT "Enter directory";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            x = CreateDirectoryA(f$, 0)
                            COLOR 14
                            IF x = 0 THEN
                                PRINT "Error 0x" + HEX$(GetLastError) + " creating directory."
                                PRINT DisplayWinError$(x)
                            ELSE
                                PRINT "Directory created."
                            END IF
                        END IF
                    CASE "R"
                        PRINT "Enter directory";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            x = RemoveDirectoryA(f$)
                            COLOR 14
                            IF x = 0 THEN
                                PRINT "Error 0x" + HEX$(GetLastError) + " removing directory."
                                PRINT DisplayWinError$(x)
                            ELSE
                                PRINT "Directory removed."
                            END IF
                        END IF
                    CASE "S"
                        PRINT "Enter directory";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            x = SetCurrentDirectoryA(f$)
                            COLOR 14
                            IF x = 0 THEN
                                PRINT "Error 0x" + HEX$(GetLastError) + " changing directory."
                                PRINT DisplayWinError$(x)
                            ELSE
                                PRINT "Directory changed."
                            END IF
                        END IF
                END SELECT
            LOOP
        CASE "F"
            DO
                COLOR 15
                PRINT "File Options:"
                PRINT "  (A)ppend file"
                PRINT "  (C)opy file"
                PRINT "  (D)elete file"
                PRINT "  (E)ncrypt file"
                PRINT "  (M)ake file"
                PRINT "  (R)ename file"
                PRINT "  (T)est file"
                PRINT "  (U)nencrypt file"
                PRINT "  (Q)uit"
                PRINT "Enter option?";
                DO
                    _LIMIT 50
                    LOCATE , , 1
                    x$ = INKEY$
                    IF LEN(x$) THEN
                        PRINT
                        EXIT DO
                    END IF
                LOOP
                IF UCASE$(x$) = "Q" THEN EXIT DO
                SELECT CASE UCASE$(x$)
                    CASE "T"
                        PRINT "Enter filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            x = FileEncryptionStatusA(f$, f&)

                            'FileEncryptionStatus return variable:

                            '0 = can be encrypted
                            '1 = file is encrypted
                            '2 = file is a system file (cannot be encrypted)
                            '3 = file is root (cannot be encryped)
                            '4 = file is system directory (cannot be encrypted)
                            '5 = encryption status unknown. file may be encrypted
                            '6 = file system does not support file encryption
                            '7 = reserved
                            '8 = file is read-only

                            IF x = 0 THEN
                                PRINT "Error 0x" + HEX$(GetLastError) + " accessing file."
                                PRINT DisplayWinError$(x)
                            END IF
                            IF x THEN
                                SELECT CASE f&
                                    CASE 0
                                        PRINT "File can be encrypted."
                                    CASE 1
                                        PRINT "File is encrypted."
                                    CASE 2
                                        PRINT "File is system."
                                    CASE 3
                                        PRINT "File is root."
                                    CASE 4
                                        PRINT "File is system directory."
                                    CASE 5
                                        PRINT "Encryption status unknown."
                                    CASE 6
                                        PRINT "File system does not support encryption."
                                    CASE 7 ' reserved
                                    CASE 8
                                        PRINT "File is read-only."
                                END SELECT
                            END IF
                        END IF
                    CASE "E"
                        PRINT "Enter filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            x = EncryptFile(f$)
                            COLOR 14
                            IF x = 0 THEN
                                PRINT "Error 0x" + HEX$(GetLastError) + " encrypting file."
                                PRINT DisplayWinError$(x)
                            ELSE
                                PRINT "File encrypted."
                            END IF
                        END IF
                    CASE "U"
                        PRINT "Enter filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            x = DecryptFile(f$, 0) ' 0=reserved
                            COLOR 14
                            IF x = 0 THEN
                                PRINT "Error 0x" + HEX$(GetLastError) + " decrypting file."
                                PRINT DisplayWinError$(x)
                            ELSE
                                PRINT "File decrypted."
                            END IF
                        END IF
                    CASE "D"
                        PRINT "Enter filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            x = DeleteFileA(f$)
                            COLOR 14
                            IF x = 0 THEN
                                PRINT "Error 0x" + HEX$(GetLastError) + " deleting file."
                                PRINT DisplayWinError$(x)
                            ELSE
                                PRINT "File deleted."
                            END IF
                        END IF
                    CASE "A"
                        PRINT "Enter filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            handle& = CreateFile(f$, &H180, 0, 0, 4, 0, 0)
                            COLOR 14
                            IF handle& > 0 THEN
                                PRINT "File append (handle=";
                                PRINT LTRIM$(STR$(handle&)); ")"
                                x = CloseHandle(handle&)
                            ELSE
                                PRINT "Error 0x" + HEX$(GetLastError) + " appending file."
                                PRINT DisplayWinError$(x)
                            END IF
                        END IF
                    CASE "M"
                        PRINT "Enter filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            f$ = f$ + CHR$(0)
                            handle& = CreateFile(f$, &H180, 0, 0, 1, 0, 0)
                            COLOR 14
                            IF handle& > 0 THEN
                                PRINT "File created (handle=";
                                PRINT LTRIM$(STR$(handle&)); ")"
                                x = CloseHandle(handle&)
                            ELSE
                                PRINT "Error 0x" + HEX$(GetLastError) + " creating file."
                                PRINT DisplayWinError$(x)
                            END IF
                        END IF
                    CASE "R"
                        PRINT "Enter filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            PRINT "Enter new filename";
                            INPUT g$
                            IF g$ <> "" THEN
                                f$ = f$ + CHR$(0)
                                g$ = g$ + CHR$(0)
                                x = MoveFile(f$, g$)
                                COLOR 14
                                IF x = 0 THEN
                                    PRINT "Error 0x" + HEX$(GetLastError) + " renaming filename."
                                    PRINT DisplayWinError$(x)
                                ELSE
                                    PRINT "Filename renamed."
                                END IF
                            END IF
                        END IF
                    CASE "C"
                        PRINT "Enter source filename";
                        INPUT f$
                        IF f$ <> "" THEN
                            PRINT "Enter dest filename";
                            INPUT g$
                            IF g$ <> "" THEN
                                f$ = f$ + CHR$(0)
                                g$ = g$ + CHR$(0)
                                x = CopyFile(f$, g$, 0) ' 0=overwrite, -1=don't
                                COLOR 14
                                IF x = 0 THEN
                                    PRINT "Error 0x" + HEX$(GetLastError) + " copying filename."
                                    PRINT DisplayWinError$(x)
                                ELSE
                                    PRINT "Filename copied."
                                END IF
                            END IF
                        END IF
                END SELECT
            LOOP
    END SELECT
LOOP
END

FUNCTION DisplayWinError$ (x)
' define error message space
DIM m AS STRING * 32767
' call windows error message routine
x& = FormatMessageA&(&H1200, "", GetLastError, 0, m$, 260, "")
IF x& THEN
    DisplayWinError$ = LEFT$(m$, x& - 2)
END IF
END FUNCTION

' parameters:
'   (1) pointer to filename
'   (2) access:
'     x80(128)  - read
'     x100(256) - write
'   (3) sharing
'   (4) security attributes
'   (5) create:
'     1 CREATE_NEW    = create only if not exist
'     2 CREATE_ALWAYS = always create new file
'     3 OPEN_EXISTING = open only if exists
'     4 OPEN_ALWAYS   = open file always
'     5 TRUNCATE_EXISTING = open/truncate to 0 only if exists
'   (6) - flags (standard OSHA)

